import { IStoreService } from './sources/store-service.interface';
import { IRipper } from './services/json-ripper.interface';
import { Injector } from '@angular/core';
import { Service } from './service';
import { Resource } from './resource';
import { JsonapiConfig } from './jsonapi-config';
import { Http as JsonapiHttpImported } from './sources/http.service';
import { IDocumentResource } from './interfaces/data-object';
import { Observable } from 'rxjs';
import { IDocumentData } from './interfaces/document';
import * as i0 from "@angular/core";
export declare const JSONAPI_RIPPER_SERVICE: string;
export declare const JSONAPI_STORE_SERVICE: string;
export declare class Core {
    static me: Core;
    static injectedServices: {
        JsonapiStoreService: IStoreService;
        JsonapiHttp: JsonapiHttpImported;
        json_ripper: IRipper;
        rsJsonapiConfig: JsonapiConfig;
    };
    loadingsCounter: number;
    loadingsStart: Function;
    loadingsDone: Function;
    loadingsError: Function;
    loadingsOffline: Function;
    config: JsonapiConfig;
    private resourceServices;
    constructor(user_config: JsonapiConfig, jsonapiHttp: JsonapiHttpImported, injector: Injector);
    static delete(path: string): Observable<IDocumentData>;
    static get(path: string): Observable<IDocumentData>;
    static exec(path: string, method: string, data?: IDocumentResource, call_loadings_error?: boolean): Observable<IDocumentData>;
    registerService<R extends Resource>(clase: Service): Service<R> | false;
    getResourceService(type: string): Service | undefined;
    getResourceServiceOrFail(type: string): Service;
    static removeCachedResource(resource_type: string, resource_id: string): void;
    static setCachedResource(resource: Resource): void;
    static deprecateCachedCollections(type: string): void;
    refreshLoadings(factor: number): void;
    clearCache(): Promise<boolean>;
    duplicateResource<R extends Resource>(resource: R, ...relations_alias_to_duplicate_too: Array<string>): R;
    static ɵfac: i0.ɵɵFactoryDeclaration<Core, [{ optional: true; }, null, null]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<Core>;
}
